/*****************************************************************************/
/***************************** Very important defines ************************/
/*****************************                        ************************/
/*****************************  Please make a choice  ************************/
/*****************************************************************************/
/*****************************************************************************/

//-------------------------------- Use LCD? -----------------------------------

#define LCD

//---------------------------- Use BoardCheck? --------------------------------

//#define BRD_CHECK

//---------------------------- Which LCD to use -------------------------------

// PLEASE DEFINE ONLY ONE !!!

//#define LCD16X2 // EA-DOGM162
#define LCD16X3 //EA-DOGM163

/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/

#define PORTA	0x05
#define PORTB  0x06
#define PORTC	0x07

#define LOW 0
#define HIGH 1

#define DOG_ADDRESS 0x48
#define nop() {#asm nop #endasm}

#define DEST_PHONE 0
#define DEST_PIC 0x0C

#define SOURCE_PHONE 0
#define SOURCE_PIC 0x0C

#define VP_CODE 0 //0xA7
#define SMS_STORE_LOCATION 1

/********************************* Lengths ***********************************/

#define MAX_IN_FRAME_LENGTH 95
#define MAX_OUT_FRAME_LENGTH 80
#define ACK_LENGTH 10

#define SMS_RX_FRAME_LENGTH 60
#define SMS_TX_FRAME_LENGTH 66
#define NETWORK_STATUS_FRAME_LENGTH 30
#define PHONE_STATUS_FRAME_LENGTH 18
#define PHONE_STATUS_LONGFRAME_LENGTH 20

#define SMS_MESSAGE_LENGTH 0x0E

#define SMSC_NUMBER_LENGTH 7
#define DEST_NUMBER_LENGTH 0x0C

/********************************* Headers ***********************************/

#define IR_FRAME_HEADER 0x1C
#define SERIAL_FRAME_HEADER 0x1E

#define COMMON_FRAME_HEADER 0, 1, 0
#define SEND_SMS_HEADER 1, 2, 0
#define GET_SMSC_HEADER 0x33, 0x64, 1

/***************************** Message frames ********************************/

#define SMS_DEL_FRAME_7110 0x0A, 8, 0, 1, 1
#define SMS_DEL_FRAME 0x0A, 2, SMS_STORE_LOCATION
#define SMS_STATUS_FRAME_7110 7, 8, 0, 1, 1, 0x65, 1
#define GET_HWSW_FRAME 3, 0

/***************************** Message types *********************************/

#define PHONE_STATUS_MESSAGE_TYPE 0x0D
#define NETWORK_STATUS_MESSAGE_TYPE 0x0A
#define SMS_FUNCTIONS_MESSAGE_TYPE 0x14
#define SMS_HANDLING_MESSAGE_TYPE 0x02
#define GET_HWSW_MESSAGE_TYPE 0xD1
#define GIVE_HWSW_MESSAGE_TYPE 0xD2

#define ACK_MESSAGE_TYPE 0x7F
#define TPDU_MESSAGE_TYPE 0x01 //0x15

/****************************** Number types **********************************/

#define SMSC_NUMBER_TYPE 0x91
#define DEST_NUMBER_TYPE 0x91

/******************************** Numbers *************************************/

#define SMSC_NUMBER 0x94, 0x71, 0x22, 0x72, 0x30, 0x33 // Octet format
#define DESTINATION_NUMBER 0x94, 0x71, 0x63, 0x99, 0x32, 0x10
#define SOURCE_NUMBER 0x94, 0x71, 0x63, 0x99, 0x32, 0x10


