#use rs232(baud=115200,xmit=PIN_C6,rcv=PIN_C7,parity=n,bits=8,errors,STREAM=PHONE_STREAM)
#include </include/usart.c>

#SEPARATE CHAR timed_fgetc(){

INT32 TIMEOUT;

TIMEOUT=0;

while(!kbhit(PHONE_STREAM) && TIMEOUT<60000) { TIMEOUT++; delay_us(5); }

if(kbhit(PHONE_STREAM)) return(fgetc(PHONE_STREAM));
else return 0;}


//-----------------------------------------------------------------------------

#SEPARATE VOID ACK(INT STRING_LENGTH, INT START_VALUE){

ACK_OUT_BUFFER[6] = IN_BUFFER[START_VALUE+3];

if(IN_BUFFER[START_VALUE+5]%2 == 0)
ACK_OUT_BUFFER[7] = IN_BUFFER[STRING_LENGTH-3]-0x40;
else
ACK_OUT_BUFFER[7] = IN_BUFFER[STRING_LENGTH-4]-0x40;

crc_calc(ACK_OUT_BUFFER, ACK_LENGTH);
send_frame(ACK_OUT_BUFFER, ACK_LENGTH);}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN receive_ack(){

for(i=0; i<=9; i++)
ACK_IN_BUFFER[i]=timed_fgetc();

return 1;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN receive_status(INT START_VALUE){

for(i=START_VALUE; i < MAX_IN_FRAME_LENGTH; i++){
IN_BUFFER[i]=timed_fgetc();

if(i==START_VALUE){
if(IN_BUFFER[i] != SERIAL_FRAME_HEADER) return 0;} // Its not a valid FBUS frame

if(i==(START_VALUE+5)){

if(IN_BUFFER[START_VALUE+5]%2 != 0){

for(COUNT=(START_VALUE+6); COUNT < (IN_BUFFER[START_VALUE+5]+START_VALUE+9); COUNT++)
IN_BUFFER[COUNT]=timed_fgetc();}

if(IN_BUFFER[START_VALUE+5]%2 == 0){

for(COUNT=(START_VALUE+6); COUNT < (IN_BUFFER[START_VALUE+5]+START_VALUE+8); COUNT++)
IN_BUFFER[COUNT]=timed_fgetc();}
break;}}

ACK(COUNT, START_VALUE);

return 1;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN receive_frame(INT STRING_LENGTH, INT START_VALUE){

STRING_LENGTH += START_VALUE;

for(i=START_VALUE; i < STRING_LENGTH; i++){

IN_BUFFER[i]=timed_fgetc();

if(i==START_VALUE){
if(IN_BUFFER[i] != SERIAL_FRAME_HEADER) return 0;}} // Its not a valid FBUS frame

ACK(STRING_LENGTH, START_VALUE);
return 1;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN receive_and_check_frame(INT STRING_LENGTH, INT START_VALUE){

STRING_LENGTH += START_VALUE;

for(i=START_VALUE; i < STRING_LENGTH; i++){
IN_BUFFER[i]=fgetc(PHONE_STREAM);

if(i==START_VALUE){
if(IN_BUFFER[i] != SERIAL_FRAME_HEADER) return 0;} // Its not a valid FBUS frame

if(i==(START_VALUE+3)){
if(IN_BUFFER[i] != SMS_HANDLING_MESSAGE_TYPE) return 0;}} // We have a status or network status frame

ACK(STRING_LENGTH, START_VALUE);
return 1;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN send_frame(*SEND_STRING, INT STRING_LENGTH){

for(i=0; i < STRING_LENGTH; i++)
fputc(SEND_STRING[i], PHONE_STREAM);}


//-----------------------------------------------------------------------------

#SEPARATE VOID crc_calc(*RESULT, INT STRING_LENGTH){

CRC = 0;

ODD = (STRING_LENGTH-1);
EVEN = (STRING_LENGTH-2);

for (i=0; i < EVEN; i+=2)
CRC ^= RESULT[i];
RESULT[EVEN] = CRC;

CRC = 0;
for (i=1; i < ODD; i+=2)
CRC ^= RESULT[i];
RESULT[ODD] = CRC;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN hwsw(){ // Getting HW/SW info

BYTE CONST GET_HWSW[16] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC,
0, 0, 0, COMMON_FRAME_HEADER, GET_HWSW_FRAME, 1, 0, 0, 0, 0 };

//BYTE CONST GET_HWSW_ANALYZE[31] = { 0x56, 0x20, 0x30, 0x35, 0x2E, 0x34, 0x32, 0x0A,
//0x30, 0x34, 0x2D, 0x30, 0x38, 0x2D, 0x30, 0x33, 0x0A, 0x4E, 0x48, 0x4D, 0x2D, 0x32,
//0x0A, 0x28, 0x63, 0x29, 0x20, 0x4E, 0x4D, 0x50, 0x2E }; // V 05.42 04-08-03 NHM-2 (c) NMP.

b.SYS_READY_BUSY = 0;
CHECK_HWSW=0;
PHONE_CHECK=0;
CMP_COUNT=0;

delay_ms(10);

MESSAGE_LENGTH = 7;
SEQUENCE_NR = 0x60;

/*********************** Building HWSW request string ************************/

memcpy(OUT_BUFFER, GET_HWSW, 16);

OUT_BUFFER[3] = GET_HWSW_MESSAGE_TYPE;
OUT_BUFFER[5] = MESSAGE_LENGTH;
OUT_BUFFER[12] = SEQUENCE_NR;

/****************** Calculating CRC for HWSW request string ******************/

crc_calc(OUT_BUFFER, 16);

/************** Sending HWSW request, getting ACK and HWSW info **************/

send_frame(OUT_BUFFER, 16);
if(receive_ack()) CHECK_HWSW++;
if(receive_frame(46, 0)) CHECK_HWSW++;

/********************* Analyzing received HWSW string ************************/

//for(i=10; i<=40; i++){
//if(IN_BUFFER[i] != GET_HWSW_ANALYZE[i-10]) return 0;}

/**************** Moving HWSW info into a separate string ********************/

for(i=10; i<=40; i++) HWSW_INFO_STRING[i-10] = IN_BUFFER[i];

/*****************************************************************************/

for(i=35; i<=41; i+=2){
for(COUNT=0; COUNT < 5; COUNT++){
if(TYPE_TABLE[i][COUNT] == HWSW_INFO_STRING[COUNT+17])
CMP_COUNT++;}

if(CMP_COUNT == 5){
PHONE_CHECK = 1; // We have a 7110 compatible
break;}}

if (CHECK_HWSW == 2) return 1;
else return 0;}


//-----------------------------------------------------------------------------

#SEPARATE VOID phone_type_output(){

b.SYS_READY_BUSY = 0;

gotoxy(1, 1);
for(i=1; i<=41; i+=2){ // Parsing second string of whole table

for(COUNT=0; COUNT<=5; COUNT++){
if(TYPE_TABLE[i][COUNT] != HWSW_INFO_STRING[COUNT+17]) break;}

if(COUNT == 5){ // We have a match

lcd_putchar("Phone is a ");
gotoxy(1, 2);
for(COUNT=0; COUNT < 5; COUNT++){
printf(lcd_putchar, "%c", TYPE_TABLE[i-1][COUNT]);
STRN_CMP[COUNT] = TYPE_TABLE[i-1][COUNT];}
lcd_putchar('.');
return;}}

lcd_putchar("Error. Phone");
gotoxy(1, 2);
lcd_putchar("not supported!");}


//-----------------------------------------------------------------------------

#SEPARATE VOID hwsw_output(){

b.SYS_READY_BUSY = 0;

gotoxy(1, 1);
lcd_putchar("HW/SW info      ");

gotoxy(1, 2);
lcd_putchar("Ver: "); // Output of version
for(i=0; i<=6; i++)
printf(lcd_putchar, "%c", HWSW_INFO_STRING[i]);
for(i=0; i < 4; i++) lcd_putchar(' ');

#ifdef LCD16X2
delay_ms(2500);
gotoxy(1, 2);
#endif

#ifdef LCD16X3
gotoxy(1, 3);
#endif

lcd_putchar("Date: "); // Output of manufacture date
for(i=8; i<=15; i++)
printf(lcd_putchar, "%c", HWSW_INFO_STRING[i]);
for(i=0; i < 2; i++) lcd_putchar(' ');
delay_ms(2500);

gotoxy(1, 2);
lcd_putchar("Type: "); // Output of handy type
for(i=17; i<=21; i++)
printf(lcd_putchar, "%c", HWSW_INFO_STRING[i]);
for(i=0; i < 5; i++) lcd_putchar(' ');

#ifdef LCD16X2
delay_ms(2500);
gotoxy(1, 2);
#endif

#ifdef LCD16X3
gotoxy(1, 3);
#endif

for(i=23; i<=30; i++)
printf(lcd_putchar, "%c", HWSW_INFO_STRING[i]); // Output of copyright
for(i=0; i < 8; i++) lcd_putchar(' ');}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN get_temp(){

j = 7;
k = 1;

if(read_ext_eeprom(0x02) == 0)
TEMP_STRING_BEFORE[0]=0x2D;

TEMP_STRING_BEFORE[1]=read_ext_eeprom(0x05);
TEMP_STRING_BEFORE[1]|=0x30;
TEMP_STRING_BEFORE[2]=read_ext_eeprom(0x04);
TEMP_STRING_BEFORE[2]|=0x30;
TEMP_STRING_BEFORE[4]=read_ext_eeprom(0x03);
TEMP_STRING_BEFORE[4]|=0x30;

while(1){
for(i=0; i < j; i++)
shift_right(&TEMP_STRING_AFTER[k-1], 1, shift_right(&TEMP_STRING_BEFORE[k-1], 1, 0));
j--;
if(j==1) break;

for(i=0; i < k; i++)
shift_right(&TEMP_STRING_AFTER[k-1], 1, shift_right(&TEMP_STRING_BEFORE[k], 1, 0));
k++;}

for(i=0; i < 6; i++) shift_right(&TEMP_STRING_AFTER[k-1], 1, 0);

TEMP_STRING_AFTER[5]|=0x80;}
