#SEPARATE BOOLEAN get_smsc(){

BYTE CONST GET_SMS_CENTER[16] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC, SMS_HANDLING_MESSAGE_TYPE,
                                  0, 0, COMMON_FRAME_HEADER, GET_SMSC_HEADER, 1, 0, 0, 0 };
BOOLEAN GARBAGE_FRAME=0;

b.SYS_READY_BUSY = 0;
delay_ms(10);

MESSAGE_LENGTH = 8;
SEQUENCE_NR = IN_BUFFER[43]+1;

memcpy(OUT_BUFFER, GET_SMS_CENTER, 16);

OUT_BUFFER[5] = MESSAGE_LENGTH;
OUT_BUFFER[13] = SEQUENCE_NR;

crc_calc(OUT_BUFFER, 16);
send_frame(OUT_BUFFER, 16);

receive_ack();

for(i=0; i < 44; i++){
IN_BUFFER[i]=timed_fgetc();

if(i == 0 && IN_BUFFER[i] != SERIAL_FRAME_HEADER) return 0;

if(i == 5 && IN_BUFFER[i] == 6){ // Unknown frame on 3410
GARBAGE_FRAME=1;
break;}}

if(GARBAGE_FRAME == 1){
for(i=6; i<14; i++) IN_BUFFER[i]=timed_fgetc();
ack(14, 0);
receive_frame(44, 0);}
else ack(44, 0);

SMSC_LENGTH=IN_BUFFER[27]-1;

for(i=0; i<SMSC_LENGTH; i++) SMS_NUMBERS[i]=IN_BUFFER[i+29];

/*
for(i=0; i<=9; i++){
gotoxy(1, 1);
printf(lcd_putchar, "%i: %x ", i, ACK_IN_BUFFER[i]);
delay_ms(1800);}

for(i=0; i<=43; i++){
gotoxy(1, 1);
printf(lcd_putchar, "%i: %x ", i, IN_BUFFER[i]);
delay_ms(1800);}
*/

if(IN_BUFFER[5] == 0x24 && IN_BUFFER[9] == 0x34) return 1;
else return 0;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN sms_delete(){

BYTE CONST SMS_DEL_7110[18] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC, 0, 0, 0,
                                COMMON_FRAME_HEADER, SMS_DEL_FRAME_7110, 1, 0, 0, 0 };
BYTE CONST SMS_DEL_ANALYZE_7110[5] = { 1, 0x25, 0, 0x0B, 1 };

BYTE CONST SMS_DEL[16] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC, 0, 0, 0,
                           COMMON_FRAME_HEADER, SMS_DEL_FRAME, 1, 0, 0, 0 };
BYTE CONST SMS_DEL_ANALYZE[5] = { 1, 8, 0, 0x0B, 1 };

if(PHONE_CHECK == 1)
MESSAGE_LENGTH = 0x0A;
else
MESSAGE_LENGTH = 8;

b.SYS_READY_BUSY = 0;
delay_ms(10);

/************************* Building SMS delete string ************************/

if(PHONE_CHECK == 1)
memcpy(OUT_BUFFER, SMS_DEL_7110, 18);
else
memcpy(OUT_BUFFER, SMS_DEL, 16);

OUT_BUFFER[3] = SMS_FUNCTIONS_MESSAGE_TYPE;
OUT_BUFFER[5] = MESSAGE_LENGTH;

if(PHONE_CHECK == 1)
OUT_BUFFER[15] = IN_BUFFER[41] + 1;
else
OUT_BUFFER[13] = IN_BUFFER[41] + 1;

/****************** Calculating CRC for SMS delete string ********************/

if(PHONE_CHECK == 1)
crc_calc(OUT_BUFFER, 18);
else
crc_calc(OUT_BUFFER, 16);

/********* Sending SMS delete string, getting ACK and answer string **********/

if(PHONE_CHECK == 1)
send_frame(OUT_BUFFER, 18);
else
send_frame(OUT_BUFFER, 16);

receive_ack();
receive_frame(14, 0);

/******************** Analyzing received answer string ***********************/

if(PHONE_CHECK == 1){
for(i=6; i<=10; i++){
if(IN_BUFFER[i] != SMS_DEL_ANALYZE_7110[i-6]) return 0;}}

else{
for(i=6; i<=10; i++){
if(IN_BUFFER[i] != SMS_DEL_ANALYZE[i-6]) return 0;}}

return 1;}


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN sms_rx(){

//BYTE CONST SMS_RX_ANALYZE[12] = { SMSC_NUMBER, SOURCE_NUMBER };

BYTE CONST OUT1_ON_TEST[7] = { 0xCF, 0x2A, 0x35, 6, 0x7A, 0x3A, 1 };
BYTE CONST OUT1_OFF_TEST[7] = { 0xCF, 0x2A, 0x35, 6, 0x7A, 0x1A, 0x8D };
BYTE CONST OUT2_ON_TEST[7] = { 0xCF, 0x2A, 0x55, 6, 0x7A, 0x3A, 1 };
BYTE CONST OUT2_OFF_TEST[7] = { 0xCF, 0x2A, 0x55, 6, 0x7A, 0x1A, 0x8D };
BYTE CONST TEMP_TEST[7] = { 0xC7, 0x22, 0x15, 0x44, 0x2D, 0x36, 0xA1 };

BYTE CONST SMS_STATUS_7110[20] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC, SMS_FUNCTIONS_MESSAGE_TYPE,
                                   0, 0, COMMON_FRAME_HEADER, SMS_STATUS_FRAME_7110, 1, 0, 0, 0 };

b.SYS_READY_BUSY = 1;
PHONE_TYPE = 0;
COUNT = 0;
TX_INFO_FLAG = 0;
MESSAGE_LENGTH = 0x0C;
SEQUENCE_NR = 0x40;

/*************************** Selecting phone type ****************************/

for(i=0; i < 4; i++){
if(STRN_CMP[i] == TYPE_TABLE[20][i]) COUNT++;}
if(COUNT == 4) PHONE_TYPE = 1;
COUNT = 0;
for(i=0; i < 4; i++){
if(STRN_CMP[i] == TYPE_TABLE[34][i]) COUNT++;}
if(COUNT == 4) PHONE_TYPE = 2;

/********************* Printing "waiting string" to LCD **********************/

lcd_putchar(VERSION_STRING);
gotoxy(1, 2);

if(PHONE_CHECK == 0)
lcd_putchar("waiting for SMS.");
else
lcd_putchar("searching a SMS.");

//gotoxy(1, 3);
//printf(lcd_putchar, "Phone type is %i.", PHONE_TYPE);

/*************** Searching for SMS string on 7110 compatible *****************/

if(PHONE_CHECK == 1){
while(1){

memcpy(OUT_BUFFER, SMS_STATUS_7110, 20);

OUT_BUFFER[3] = SMS_FUNCTIONS_MESSAGE_TYPE;
OUT_BUFFER[5] = MESSAGE_LENGTH;

SEQUENCE_NR++;
if(SEQUENCE_NR == 0x50) SEQUENCE_NR = 0x40;
OUT_BUFFER[17] = SEQUENCE_NR;

crc_calc(OUT_BUFFER, 20);
send_frame(OUT_BUFFER, 20);

receive_ack();
receive_status(20);

gotoxy(1, 1);
blanking();

if(IN_BUFFER[25] == 0x07){ // No SMS in Inbox
lcd_putchar("No SMS in Inbox.");
delay_ms(5000);
blanking();}

if(IN_BUFFER[25] == 0x35 || IN_BUFFER[25] == 0x36){ // SMS found in Inbox
lcd_putchar("SMS found!      ");
b.SYS_READY_BUSY = 0;
blanking();

/*********************** Analyzing received SMS string ***********************/
/*
for(i=37; i<=42; i++){ // Analyzing the received SMS strings SMSC number
if(IN_BUFFER[i] != SMS_RX_ANALYZE[i-37]) return 0;}

for(i=53; i<=58; i++){ // Analyzing the received SMS strings source number
if(IN_BUFFER[i] != SMS_RX_ANALYZE[i-47]) return 0;}
*/
/*************** Analyzing received SMS string to switch relay ***************/

if(IN_BUFFER[72] == 0x35 && IN_BUFFER[75] == 0x3A){ a.OUT_1 = 1; return 1; }
if(IN_BUFFER[72] == 0x35 && IN_BUFFER[75] == 0x1A){ a.OUT_1 = 0; return 1; }
if(IN_BUFFER[72] == 0x55 && IN_BUFFER[75] == 0x3A){ a.OUT_2 = 1; return 1; }
if(IN_BUFFER[72] == 0x55 && IN_BUFFER[75] == 0x1A){ a.OUT_2 = 0; return 1; }

for(i=50; i<=56; i++){
if(IN_BUFFER[i] != TEMP_TEST[i-50]) return 0;}

TX_INFO_FLAG = 1;
return 1;}

if(IN_BUFFER[25] != 0x07 && IN_BUFFER[25] != 0x35 && IN_BUFFER[25] != 0x36) return 0;}}

/**************** Receiving SMS string on 6110 compatible ********************/

else{
while(1){
if(receive_and_check_frame(SMS_RX_FRAME_LENGTH, 0)==0) continue;
else break;}

b.SYS_READY_BUSY = 0;

/************************* Receiving status strings **************************/

if(PHONE_TYPE == 1){
receive_frame(PHONE_STATUS_LONGFRAME_LENGTH, SMS_RX_FRAME_LENGTH);
receive_frame(PHONE_STATUS_LONGFRAME_LENGTH, SMS_RX_FRAME_LENGTH);}

receive_frame(NETWORK_STATUS_FRAME_LENGTH, SMS_RX_FRAME_LENGTH);

/*********************** Analyzing received SMS string ***********************/
/*
for(i=15; i<=20; i++){ // Analyzing the received SMS strings SMSC number
if(IN_BUFFER[i] != SMS_RX_ANALYZE[i-15]) return 0;}

for(i=31; i<=36; i++){ // Analyzing the received SMS strings source number
if(IN_BUFFER[i] != SMS_RX_ANALYZE[i-25]) return 0;}
*/
/*************** Analyzing received SMS string to switch relay ***************/

if(IN_BUFFER[50] == 0x35 && IN_BUFFER[53] == 0x3A){ a.OUT_1 = 1; return 1; }
if(IN_BUFFER[50] == 0x35 && IN_BUFFER[53] == 0x1A){ a.OUT_1 = 0; return 1; }
if(IN_BUFFER[50] == 0x55 && IN_BUFFER[53] == 0x3A){ a.OUT_2 = 1; return 1; }
if(IN_BUFFER[50] == 0x55 && IN_BUFFER[53] == 0x1A){ a.OUT_2 = 0; return 1; }

for(i=48; i<=54; i++){
if(IN_BUFFER[i] != TEMP_TEST[i-48]) return 0;} // Return '0' if nothing compares

TX_INFO_FLAG = 1;
return 1;}} // If "TEMP_TEST" compares


//-----------------------------------------------------------------------------

#SEPARATE BOOLEAN sms_tx(){

BYTE CONST COMMON_SEND_FRAME[66] = { SERIAL_FRAME_HEADER, DEST_PHONE, SOURCE_PIC, 0, 0, 0,
                                     COMMON_FRAME_HEADER, SEND_SMS_HEADER, SMSC_NUMBER_LENGTH,
                                     SMSC_NUMBER_TYPE, SMSC_NUMBER, 0, 0, 0, 0, TPDU_MESSAGE_TYPE,
                                     0, 0, 0, SMS_MESSAGE_LENGTH, DEST_NUMBER_LENGTH, DEST_NUMBER_TYPE,
                                     DESTINATION_NUMBER, 0, 0, 0, 0, VP_CODE, 0, 0, 0, 0, 0, 0, 0,
                                     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0 }; // Common big SMS send frame

BYTE CONST SEND_FRAME_OUT1_ON[13] = { 0xCF, 0x2A, 0x35, 6, 0x92, 0x16, 0x99, 0xC1, 0x2C, 0xE8, 0xE9, 4, 1 };
BYTE CONST SEND_FRAME_OUT1_OFF[13] = { 0xCF, 0x2A, 0x35, 6, 0x92, 0x16, 0x99, 0xC1, 0x2C, 0xE8, 0x69, 0x34, 2 };
BYTE CONST SEND_FRAME_OUT2_ON[13] = { 0xCF, 0x2A, 0x55, 6, 0x92, 0x16, 0x99, 0xC1, 0x2C, 0xE8, 0xE9, 4, 1 };
BYTE CONST SEND_FRAME_OUT2_OFF[13] = { 0xCF, 0x2A, 0x55, 6, 0x92, 0x16, 0x99, 0xC1, 0x2C, 0xE8, 0x69, 0x34, 2 };
BYTE CONST SEND_FRAME_BOTH_ON[13] = { 0xCF, 0x2A, 0x35, 6, 0x32, 0x81, 0x64, 0xA0, 0xA7, 0x13, 4, 2, 1 };
BYTE CONST SEND_FRAME_BOTH_OFF[13] = { 0xCF, 0x2A, 0x35, 6, 0x32, 0x81, 0x64, 0xA0, 0xA7, 0xD1, 8, 2, 1 };

BYTE CONST SMS_TX_ANALYZE[8] = { 1, 8, 0, 2, 0x64, 0, 1 };
BYTE CONST SMS_TX_ANALYZE_7110[8] = { 1, 0x24, 0, 2, 0x65, 0, 1 };


b.SYS_READY_BUSY = 0;
delay_ms(10);

/***************** Getting SMSC & source number from buffer ******************/

if(PHONE_CHECK == 1){
for(i=53; i<=58; i++) SMS_NUMBERS[i-43] = IN_BUFFER[i];}

else{
for(i=31; i<=36; i++) SMS_NUMBERS[i-21] = IN_BUFFER[i];}

/*****************************************************************************/

MESSAGE_LENGTH = 0x39;
SEQUENCE_NR = 0x41;

memcpy(OUT_BUFFER, COMMON_SEND_FRAME, 66);

/****************** Deciding which string to copy in buffer ******************/

if(TX_INFO_FLAG==1){
get_temp();
for(i=48; i<=60; i++)
OUT_BUFFER[i] = TEMP_STRING_AFTER[i-48];}

if(TX_INFO_FLAG==0){
if(input(PIN_A4) && !input(PIN_A5)){
for(i=48; i<=60; i++)
OUT_BUFFER[i] = SEND_FRAME_OUT1_ON[i-48];}

if(!input(PIN_A4) && input(PIN_A5)){
for(i=48; i<=60; i++)
OUT_BUFFER[i] = SEND_FRAME_OUT2_ON[i-48];}

if(input(PIN_A4) && input(PIN_A5)){
for(i=48; i<=60; i++)
OUT_BUFFER[i] = SEND_FRAME_BOTH_ON[i-48];}

if(!input(PIN_A4) && !input(PIN_A5)){
for(i=48; i<=60; i++)
OUT_BUFFER[i] = SEND_FRAME_BOTH_OFF[i-48];}}

/************************* Building SMS send string **************************/

OUT_BUFFER[3] = SMS_HANDLING_MESSAGE_TYPE;
OUT_BUFFER[5] = MESSAGE_LENGTH;

for(i=14; i<=19; i++) OUT_BUFFER[i] = SMS_NUMBERS[i-14]; // Put SMSC number in string
for(i=31; i<=36; i++) OUT_BUFFER[i] = SMS_NUMBERS[i-21]; // Put destination number (once source number) in string

OUT_BUFFER[62] = SEQUENCE_NR;

/******************** Calculating CRC for SMS send string ********************/

crc_calc(OUT_BUFFER, SMS_TX_FRAME_LENGTH);

/************ Sending out SMS send string, getting ACK & strings *************/

if(PHONE_TYPE == 0 || PHONE_TYPE == 2)
send_frame(OUT_BUFFER, SMS_TX_FRAME_LENGTH);

if(PHONE_TYPE == 1){
usart_sync();
usart_clear();
send_frame(OUT_BUFFER, SMS_TX_FRAME_LENGTH);}

receive_ack();

if(PHONE_CHECK == 1)
receive_frame(18, 0);

else{
if(PHONE_TYPE == 0){
receive_frame(14, 60); // If not ACKd, phone will crash down
receive_frame(18, 0);
receive_frame(NETWORK_STATUS_FRAME_LENGTH, 20);}

if(PHONE_TYPE == 1){
receive_frame(18, 0);
receive_frame(NETWORK_STATUS_FRAME_LENGTH, 20);}}

/*************** Analyzing the received 'Message sent' string ****************/

if(PHONE_CHECK == 1){
for(i=6; i<=10; i++){
if(IN_BUFFER[i] != SMS_TX_ANALYZE_7110[i-6]) return 0;}
for(i=12; i<=13; i++){
if(IN_BUFFER[i] != SMS_TX_ANALYZE_7110[i-7]) return 0;}}

else{
for(i=6; i<=10; i++){
if(IN_BUFFER[i] != SMS_TX_ANALYZE[i-6]) return 0;}
for(i=12; i<=13; i++){
if(IN_BUFFER[i] != SMS_TX_ANALYZE[i-7]) return 0;}}

return 1;}
